var bvqx = BrainVoyagerQX; // use short symbol to access BrainVoyager QX APIvar

scriptObj = new Object;
scriptObj.dialogFileName = "VTCinspector1_0.ui";
scriptObj.dialogAccessName = "PluginDialog";

scriptObj.initDlg = function()
{
    var dlg = this.PluginDialog; // less to write
    dlg.options.delete_other_vmps.checked = 1;
    dlg.options.add_vtc_name.checked = 1;

    dlg.maps.create_TSNR_map.checked = 0;
    dlg.maps.create_lagged_autocor_map.checked = 0;
    dlg.maps.create_outlier_map.checked = 1;

    dlg.parameters.max_deviation.minimum = 1.0;
    dlg.parameters.max_deviation.maximum = 9.9;
    dlg.parameters.max_deviation.singleStep = 0.1;
    dlg.parameters.max_deviation.value = 4;

    dlg.parameters.spike_def.minimum = 1.0;
    dlg.parameters.spike_def.maximum = 9.9;
    dlg.parameters.spike_def.singleStep = 0.1;
    dlg.parameters.spike_def.value = 3;

    dlg.temporal.create_temporal_outlier_logtab.checked = 1;
    dlg.temporal.create_temporal_outlier_file.checked = 0;

    //connect UI Elements to script functions
    dlg.addButton.clicked.connect(this, this.onAdd);
    dlg.mdmButton.clicked.connect(this, this.onMDM);
    dlg.clearButton.clicked.connect(this, this.onClear);
    dlg.startButton.clicked.connect(this, this.onStart);
    dlg.cancelButton.clicked.connect(this, this.onCancel);
}

scriptObj.onAdd = function() {
    var dlg = this.PluginDialog;

    bvqx.PrintToLog("Script>  Dialog's Add VTC button clicked");

    bvqx.SetPluginStringParameter("Command", "AddFile");
    bvqx.SetPluginStringParameter("FileList", dlg.tbrFileList.plainText);

    bvqx.ExecutePlugin();

    var newFileList = bvqx.GetPluginStringParameter("FileList"); // get result from plugin

    dlg.tbrFileList.plainText = newFileList;
}

scriptObj.onMDM = function() {
    var dlg = this.PluginDialog;

    bvqx.PrintToLog("Script>  Dialog's Add MDM button clicked");

    bvqx.SetPluginStringParameter("Command", "AddMDM");
    bvqx.SetPluginStringParameter("FileList", dlg.tbrFileList.plainText);

    bvqx.ExecutePlugin();

    var newFileList = bvqx.GetPluginStringParameter("FileList"); // get result from plugin

    dlg.tbrFileList.plainText = newFileList;
}

scriptObj.onClear = function() {
    var dlg = this.PluginDialog;
    bvqx.PrintToLog("Script>  Dialog's Clear List button clicked");
    dlg.tbrFileList.plainText = "";
}


scriptObj.onCancel = function()
{
    bvqx.PrintToLog("Script>  Cancel Clicked - closing dialog");
    this.PluginDialog.close();
}

scriptObj.onStart = function()
{
    var dlg = this.PluginDialog;
    bvqx.PrintToLog("Script>  Dialog info to Brainvoyager");
    bvqx.SetPluginStringParameter("Command", "Start");

    bvqx.SetPluginIntParameter("Delete_Other_Vmps", dlg.options.delete_other_vmps.checked);
    bvqx.SetPluginIntParameter("Add_Vtc_Name", dlg.options.add_vtc_name.checked);

    bvqx.SetPluginIntParameter("Create_TSNR_Map", dlg.maps.create_TSNR_map.checked);
    bvqx.SetPluginIntParameter("Create_Lagged_Autocor_Map", dlg.maps.create_lagged_autocor_map.checked);
    bvqx.SetPluginIntParameter("Create_Outlier_Map", dlg.maps.create_outlier_map.checked);

    bvqx.SetPluginFloatParameter("Max_Deviation", dlg.parameters.max_deviation.value);
    bvqx.SetPluginFloatParameter("Spike_Def", dlg.parameters.spike_def.value);
    bvqx.SetPluginIntParameter("Create_Temporal_Outlier_Logtab", dlg.temporal.create_temporal_outlier_logtab.checked);
    bvqx.SetPluginIntParameter("Create_Temporal_Outlier_File", dlg.temporal.create_temporal_outlier_file.checked);
    bvqx.PrintToLog("Script>  Closing dialog");
    dlg.close();
    bvqx.ExecutePlugin();
}

returnScriptObj = function()
{
    return scriptObj;
}
returnScriptObj(); // we call this at the end to return created script object to BrainVoyager QX